/*
  IWT255.h - Tokyo Devices IWT255 Library 1.0.1
  http://tokyodevices.jp/
  Copyright (C) 2013-2014 I.W. Technology Firm, Inc.
*/

#ifndef IWT255_h
#define IWT255_h

#include "Arduino.h"

#define IWT255_SLAVE_ADDR   0x32
#define RTC_SLAVE_ADDR      0x51
#define RTC_REG_SEC_ADDR    0x02

class IWT255Impl
{

public:

  IWT255Impl();
  
  void begin();
  
  void powerOff();
  
  void setDateTime(uint8_t data[], uint8_t length);
  void setDateTime(uint8_t year,
		   uint8_t month,
		   uint8_t day,
		   uint8_t wday,
		   uint8_t hour,
		   uint8_t min,
		   uint8_t sec);

  void setMinuteTimer(bool, uint8_t);
  void setHourTimer(bool, uint8_t);
  void setDayTimer(bool, uint8_t);
  void setWeekdayTimer(bool, uint8_t);
  
  void startTimer();
  void clearTimer();

  void readDateTime();
  uint8_t getYear();
  uint8_t getMonth();
  uint8_t getDay();
  uint8_t getWeekday();
  uint8_t getHour();
  uint8_t getMinute();
  uint8_t getSecond();

private:

  uint8_t year;
  uint8_t month;
  uint8_t day;
  uint8_t weekday;
  uint8_t hour;
  uint8_t minute;
  uint8_t second;

  uint8_t toDEC(uint8_t bcd);
  uint8_t toBCD(uint8_t dec);

};

extern IWT255Impl IWT255;

#endif
